Loading...
Searching...
No Matches
juce::AudioCDReader Class Reference

## Detailed Description

A type of AudioFormatReader that reads from an audio CD.

One of these can be used to read a CD as if it's one big audio stream. Use the getPositionOfTrackStart() method to find where the individual tracks are within the stream.

See also
  AudioFormatReader

The documentation for this class was generated from the following file:

- juce_audio_utils/audio_cd/juce_AudioCDReader.h

Inheritance diagram for juce::AudioCDReader:

## Public Types

enum | { framesPerSecond = 75 , samplesPerFrame = 44100 / framesPerSecond }

## Public Member Functions

| ~AudioCDReader () override
| Destructor.
bool | readSamples (int *const *destSamples, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int numSamples) override
| Implementation of the AudioFormatReader method.
bool | isCDStillPresent () const
| Checks whether the CD has been removed from the drive.
int | getNumTracks () const
| Returns the total number of tracks (audio + data).
int | getPositionOfTrackStart (int trackNum) const
| Finds the sample offset of the start of a track.
bool | isTrackAudio (int trackNum) const
| Returns true if a given track is an audio track.
const Array< int > & | getTrackOffsets () const
| Returns an array of sample offsets for the start of each track, followed by the sample position of the end of the CD.
void | refreshTrackLengths ()
| Refreshes the object's table of contents.
void | enableIndexScanning (bool enabled)
| Enables scanning for indexes within tracks.
int | getLastIndex () const
| Returns the index number found during the last read() call.
Array< int > | findIndexesInTrack (int trackNumber)
| Scans a track to find the position of any indexes within it.
int | getCDDBId ()
| Returns the CDDB id number for the CD.
void | ejectDisk ()
| Tries to eject the disk.
Public Member Functions inherited from juce::AudioFormatReader
virtual | ~AudioFormatReader ()
| Destructor.
const String & | getFormatName () const noexcept
| Returns a description of what type of format this is.
bool | read (float *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead)
| Reads samples from the stream.
bool | read (int *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead, bool fillLeftoverChannelsWithCopies)
| Reads samples from the stream.
bool | read (AudioBuffer< float > *buffer, int startSampleInDestBuffer, int numSamples, int64 readerStartSample, bool useReaderLeftChan, bool useReaderRightChan)
| Fills a section of an AudioBuffer from this reader.
virtual void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead)
| Finds the highest and lowest sample levels from a section of the audio stream.
virtual void | readMaxLevels (int64 startSample, int64 numSamples, float &lowestLeft, float &highestLeft, float &lowestRight, float &highestRight)
| Finds the highest and lowest sample levels from a section of the audio stream.
int64 | searchForLevel (int64 startSample, int64 numSamplesToSearch, double magnitudeRangeMinimum, double magnitudeRangeMaximum, int minimumConsecutiveSamples)
| Scans the source looking for a sample whose magnitude is in a specified range.
virtual AudioChannelSet | getChannelLayout ()
| Get the channel layout of the audio stream.

## Static Public Member Functions

static StringArray | getAvailableCDNames ()
| Returns a list of names of Audio CDs currently available for reading.
static AudioCDReader * | createReaderForCD (int index)
| Tries to create an AudioFormatReader that can read from an Audio CD.

## Additional Inherited Members

Public Attributes inherited from juce::AudioFormatReader
double | sampleRate = 0
| The sample-rate of the stream.
unsigned int | bitsPerSample = 0
| The number of bits per sample, e.g.
int64 | lengthInSamples = 0
| The total number of samples in the audio stream.
unsigned int | numChannels = 0
| The total number of channels in the audio stream.
bool | usesFloatingPointData = false
| Indicates whether the data is floating-point or fixed.
StringPairArray | metadataValues
| A set of metadata values that the reader has pulled out of the stream.
InputStream * | input
| The input stream, for use by subclasses.
Protected Member Functions inherited from juce::AudioFormatReader
| AudioFormatReader (InputStream *sourceStream, const String &formatName)
| Creates an AudioFormatReader object.
Static Protected Member Functions inherited from juce::AudioFormatReader
static void | clearSamplesBeyondAvailableLength (int *const *destChannels, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int &numSamples, int64 fileLengthInSamples)
| Used by AudioFormatReader subclasses to clear any parts of the data blocks that lie beyond the end of their available length.

## Member Enums

## anonymous enum

anonymous enum

Enumerator
framesPerSecond |
samplesPerFrame |

## Constructors and Destructors

## ~AudioCDReader()

juce::AudioCDReader::~AudioCDReader | ( |  | ) |

override

Destructor.

## Member Functions

## getAvailableCDNames()

StringArray juce::AudioCDReader::getAvailableCDNames | ( |  | ) |

static

Returns a list of names of Audio CDs currently available for reading.

If there's a CD drive but no CD in it, this might return an empty list, or possibly a device that can be opened but which has no tracks, depending on the platform.

See also
  createReaderForCD

## createReaderForCD()

AudioCDReader * juce::AudioCDReader::createReaderForCD | ( | int | index | ) |

static

Tries to create an AudioFormatReader that can read from an Audio CD.

Parameters

  index | the index of one of the available CDs - use getAvailableCDNames() to find out how many there are.

Returns
  a new AudioCDReader object, or nullptr if it couldn't be created. The caller will be responsible for deleting the object returned.

## readSamples()

bool juce::AudioCDReader::readSamples | ( | int *const * | destSamples,
|  | int | numDestChannels,
|  | int | startOffsetInDestBuffer,
|  | int64 | startSampleInFile,
|  | int | numSamples )

override virtual

Implementation of the AudioFormatReader method.

Implements juce::AudioFormatReader.

## isCDStillPresent()

bool juce::AudioCDReader::isCDStillPresent | ( |  | ) | const

Checks whether the CD has been removed from the drive.

## getNumTracks()

int juce::AudioCDReader::getNumTracks | ( |  | ) | const

Returns the total number of tracks (audio + data).

## getPositionOfTrackStart()

int juce::AudioCDReader::getPositionOfTrackStart | ( | int | trackNum | ) | const

Finds the sample offset of the start of a track.

Parameters

  trackNum | the track number, where trackNum = 0 is the first track and trackNum = getNumTracks() means the end of the CD.

## isTrackAudio()

bool juce::AudioCDReader::isTrackAudio | ( | int | trackNum | ) | const

Returns true if a given track is an audio track.

Parameters

  trackNum | the track number, where 0 is the first track.

## getTrackOffsets()

const Array< int > & juce::AudioCDReader::getTrackOffsets | ( |  | ) | const

Returns an array of sample offsets for the start of each track, followed by the sample position of the end of the CD.

## refreshTrackLengths()

void juce::AudioCDReader::refreshTrackLengths | ( |  | ) |

Refreshes the object's table of contents.

If the disc has been ejected and a different one put in since this object was created, this will cause it to update its idea of how many tracks there are, etc.

## enableIndexScanning()

void juce::AudioCDReader::enableIndexScanning | ( | bool | enabled | ) |

Enables scanning for indexes within tracks.

See also
  getLastIndex

## getLastIndex()

int juce::AudioCDReader::getLastIndex | ( |  | ) | const

Returns the index number found during the last read() call.

Index scanning is turned off by default - turn it on with enableIndexScanning().

Then when the read() method is called, if it comes across an index within that block, the index number is stored and returned by this method.

Some devices might not support indexes, of course.

(If you don't know what CD indexes are, it's unlikely you'll ever need them).

See also
  enableIndexScanning

## findIndexesInTrack()

Array< int > juce::AudioCDReader::findIndexesInTrack | ( | int | trackNumber | ) |

Scans a track to find the position of any indexes within it.

Parameters

  trackNumber | the track to look in, where 0 is the first track on the disc

Returns
  an array of sample positions of any index points found (not including the index that marks the start of the track)

## getCDDBId()

int juce::AudioCDReader::getCDDBId | ( |  | ) |

Returns the CDDB id number for the CD.

It's not a great way of identifying a disc, but it's traditional.

## ejectDisk()

void juce::AudioCDReader::ejectDisk | ( |  | ) |

Tries to eject the disk.

Ejecting the disk might not actually be possible, e.g. if some other process is using it.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited